﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exercice : Un menu déroulant
# Fichier : Exercice 9_5.fla
# Classe : Menu.as 
*/



package {
	import flash.display.*;
	import flash.events.*;
	//Définition de la classe Menu extends Sprite
	public class Menu extends Sprite {
		// Définition des attributs de la classe
		private var entete:ItemMenuClp;
		private var listeItems:Array;
		public var estVisible:Boolean = false;



		private function aDerouler(nbr:Number):void {
			// Le menu déroule les items et devient visible
			// c. afficher "je me déroule" dans la fenêtre de sortie
			trace("Je me déroule");
		}

		private function aEnrouler(nbr:Number, p:Number):void {
			// Le menu enroule les items et devient invisible (sauf l’entete) 
			// c. afficher "je m'enroule" dans la fenêtre de sortie
			trace("Je m'enroule");
		}

		// c. Ajoute un item dans le tableau listeItems
		private function ajouterUnItem(rubrique:Array):void {
			var x:Number =  entete.x;
			var y:Number =  entete.y;
			var h:Number =  entete.height;

			// Le consrtucteur Item crée les items et les places sous l'entête
			var nvelItem:Item = new Item( x,y, rubrique);
			addChildAt(nvelItem,0);
			listeItems.push(nvelItem);
		}

		// Définition de la fonction constructeur 
		public function Menu(nom:String,  nx:Number, ny:Number, l:Array) {
			var nbRubrique:Number = l.length;
			entete = new ItemMenuClp();
			entete.x = nx;
			entete.y = ny;
			entete.labelOut.text = nom;
			addChildAt(entete,0);
			listeItems = new Array();
			for (var i:uint = 0; i < nbRubrique; i++) {
				ajouterUnItem(l[i]);
			}


			// a. Au survol de la souris, l'entete devient plus transparent
			entete.addEventListener(MouseEvent.MOUSE_OVER, auSurvol);
			// a. L'entete reprend sa couleur initiale
			entete.addEventListener(MouseEvent.MOUSE_OUT, alExterieur);
			entete.addEventListener(MouseEvent.MOUSE_UP, auClic);
		}
		private function auSurvol(e:MouseEvent):void {
			entete.alpha = 0.4;
		}
		private function alExterieur(e:MouseEvent):void {
			entete.alpha = 1;
		}

		private function auClic(e:MouseEvent):void {
			var nbRubrique:Number = listeItems.length;
			// b. Si le menu est invisible, le dérouler
			if ( !entete.estVisible) {
				aDerouler(nbRubrique);
				// Changer l'état du drapeau estVisible
				entete.estVisible = true;
			} else {
				// b. Si le menu est visible, l'enrouler
				aEnrouler(nbRubrique, entete.y);
				// Changer l'état du drapeau estVisible
				entete.estVisible = false;
			}
		}
	}
}