﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet 
# Projet Le mini site 
# Fichier : MiniSite.as
*/
package {
	import flash.display.*;
	import flash.events.*;
	import TitreClp;
	public class MiniSite extends Sprite {
		// Définition des constantes utilisées par l'ensemble de l'application
		public static  var largeurScene:uint;
		public static  var hauteurScene:uint;
		public static  const largeurMini:Number=20;
		public static  const hauteurMini:Number=35;
		public static  var largeurRubrique:uint;
		public static  var hauteurRubrique:uint;
		public static  var largeurPage:Number;
		public static  var hauteurPage:Number;
		public static  const finalXPage:uint=0;
		public static  const finalYPage:uint=150;
		public static  var finalXMini:uint=0;
		public static  var finalYMini:uint=150;


		public static  const listeCouleurs =  [ 0x016087, 0x660066, 0xCC0033, 0xFF9900];
		public static  const listeNoms = [ "Photos", "Animes", "Videos", "Infos"];
		public static  const nbElt  = [35, 6, 4, 0];

		public var listeRubriques:Array=new Array(4);
		public var listeTitreRubrique:Array=new Array(4);



		public function MiniSite(nlar:uint, nhau:uint) {
			// Initialisation des tailles des rubriques et de pages, des positions des minis rubriques
			largeurScene=nlar;
			hauteurScene=nhau;
			largeurRubrique=largeurScene / 4;
			hauteurRubrique=hauteurScene - 150;
			largeurPage=largeurScene;
			hauteurPage=hauteurScene - 150;
			finalYMini=100;
			finalXMini=MiniSite.largeurScene - 100;
			var i:uint;
			// Afficher et traiter le titre
			var titreSite:TitreClp=new TitreClp();
			titreSite.x=20;
			titreSite.y=150;
			addChild(titreSite);
			titreSite.addEventListener(MouseEvent.MOUSE_OVER,surOver);
			titreSite.addEventListener(MouseEvent.MOUSE_OUT,surOut);
			titreSite.addEventListener(MouseEvent.MOUSE_UP,clicSurTitre);
			// Création des rubriques
			for (i=0; i < listeNoms.length; i++) {
				listeTitreRubrique[i]=new TitreTexte(100,listeCouleurs[i],55,"Arista",listeNoms[i]);
				var posX:Number = Math.random()*(largeurScene+ 2*largeurRubrique) - largeurRubrique;
				var posY:Number = Math.random()*(hauteurScene + 2*hauteurRubrique) - hauteurRubrique;
				listeRubriques[i]=new Rubrique(i,posX,posY,listeCouleurs[i],nbElt[i],listeTitreRubrique[i]);
				addChild(listeRubriques[i]);
			}
		}
		// L'intensité du titre diminue et le curseur prend la forme d'une main
		function surOver(e:MouseEvent):void {
			var cible:Sprite=e.currentTarget  as  Sprite;
			cible.alpha=0.4;
			cible.buttonMode=true;
		}
		// L'opacité du titre  revient à l'état initial
		function surOut(e:MouseEvent):void {
			var cible:Sprite=e.currentTarget  as  Sprite;
			cible.alpha=1;
		}
		// Supprimer une pages quand on clique sur le titre
		private function supprimerLesPages():void {
			Page.lesMinisRubriques = null;
			for (var i:Number=0; i < numChildren; i++) {
				if (getChildAt(i) is Page) {
					removeChild(getChildAt(i));
				}
			}
		}
		
		// Quand on clique sur le titre la page affichée s'efface, les rubriques réapparaissent
		private function clicSurTitre(e:MouseEvent):void {
			supprimerLesPages();
			for (var i:uint=0; i < listeNoms.length; i++) {
				removeChild(listeRubriques[i]);
				listeTitreRubrique[i]=new TitreTexte(100,listeCouleurs[i],55,"Arista",listeNoms[i]);
				var posX:Number = Math.random()*(largeurScene+ 2*largeurRubrique) - largeurRubrique;
				var posY:Number = Math.random()*(hauteurScene + 2*hauteurRubrique) - hauteurRubrique;
				listeRubriques[i]=new Rubrique(i,posX,posY,listeCouleurs[i],nbElt[i],listeTitreRubrique[i]);
				addChild(listeRubriques[i]);


			}
		}
	}
}